package week03.floatingpoints;

public class DoubleDemo {

	public static void main(String[] args) {
		double i = 2.00;
		double j = 1.10;
		double result = i - j;
	
		// result is 0.8999999999999 -> floating point numbers are represent by powers of two internally; not every number can be expressed like that.
		System.out.println(result);
	
		if(result == 0.9) {
			System.out.println("Result is as expected!");
		} else {
			System.out.println("Result is unexpected!");
		}
		
		// use a range 'epsilon' instead, to define close two floating point numbers need to be, to be considered equal. 
		double epsilon = 0.05;
		if(Math.abs(result - 0.9) < epsilon) {
			System.out.println("Result is as expected!");
		} else {
			System.out.println("Result is unexpected!");
		}
	}

}
