package week03.string_equality;

public class StringEqualityTestDriver {
	public static void main(String[] args) {
		String s1 = "Hello World";
		String s2 = "Hello World";

		// String literals, i.e. Strings within quotes, are internally stored
		// only once in a String pool for efficiency. This is an optimization:
		// Never ever rely on it by using == to compare two strings. Always use
		// s1.equals(s2);
		System.out.println(s1 == s2);
		
		// If a String is created with new String("the string"), then the
		// optimization does not take place.
		String s3 = new String("Hello World");

		System.out.println(s1 == s3);
		System.out.println(s1.equals(s3));
	}
}